//+------------------------------------------------------------------+
//|                                            TestPartialOrders.mq5 |
//|                                                          tsaktuo |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "tsaktuo"
#property link      "http://www.mql5.com"
#property version   "1.00"

#include <Trade\Trade.mqh>

CTrade cTrade;
double closing_part=0.99;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   cTrade.SetDeviationInPoints(0);
   cTrade.SetExpertMagicNumber(0);
   cTrade.SetTypeFilling(ORDER_FILLING_AON);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   datetime time[1];
   static datetime last_time;

   if(PositionSelect(_Symbol))
     {
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
        {
         if(PositionGetDouble(POSITION_PROFIT)>0.0)
           {
            //Winning trade
            if(NormalizeDouble(PositionGetDouble(POSITION_PRICE_OPEN)+((PositionGetDouble(POSITION_TP)-PositionGetDouble(POSITION_PRICE_OPEN))*closing_part),_Digits)==PositionGetDouble(POSITION_PRICE_CURRENT))
              {
               //Limit reached, close half
               ClosePosition(closing_part);
              }
           }
         else
           {
            //Loosing trade
            if(NormalizeDouble(PositionGetDouble(POSITION_PRICE_OPEN)-((PositionGetDouble(POSITION_PRICE_OPEN)-PositionGetDouble(POSITION_SL))*closing_part),_Digits)==PositionGetDouble(POSITION_PRICE_CURRENT))
              {
               //Limit reached, close half
               ClosePosition(closing_part);
              }
           }
        }
      else
        {
         //Sell order
         Print("SELL order found!");
        }
     }
   else
     {
      //No orders found
      //Check if this is new Bar
      CopyTime(_Symbol,_Period,0,1,time);
      if(time[0]==last_time)
         return;
      last_time=time[0];
      //Open position
      OpenPosition();
     }
  }
//+------------------------------------------------------------------+
void ClosePosition(double lots)
  {
   if(PositionGetDouble(POSITION_VOLUME)<lots)
     {
      //Not enough volume
      return;
     }
   MqlTick tick;
   SymbolInfoTick(_Symbol,tick);
   if(cTrade.PositionOpen(_Symbol,ORDER_TYPE_SELL,lots,tick.bid,0,0,"Closing half"))
     {
      //Order closed sucessfully
     }
   else
     {
      Print("Failed to open order! Error:",cTrade.CheckResultRetcodeDescription());
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OpenPosition()
  {
   MqlTick tick;
   SymbolInfoTick(_Symbol,tick);
   double sl = tick.ask-100.0*_Point;
   double tp = tick.ask+100.0*_Point;
//There is no open positions, let's open one
   if(cTrade.PositionOpen(_Symbol,ORDER_TYPE_BUY,1.0,tick.ask,sl,tp,"Open"))
     {
      //Order sucessfully opened.
     }
   else
     {
      Print("Failed to open order! Error:",cTrade.CheckResultRetcodeDescription());
     }
  }
//+------------------------------------------------------------------+
